#
# Conditional build:
%bcond_without	spirv_opt	# build with spirv-opt capability
%bcond_without	tests		# build with tests

Summary:	Khronos reference front-end for GLSL and ESSL
Summary(pl.UTF-8):	Wzorcowy frontend GLSL i ESSL z projektu Khronos
Name:		glslang
Version:	12.3.1
Release:	1
License:	BSD-like
Group:		Applications/Graphics
#Source0Download: https://github.com/KhronosGroup/glslang/releases
Source0:	https://github.com/KhronosGroup/glslang/archive/%{version}/%{name}-%{version}.tar.gz
# Source0-md5:	0d453bdb40e79948bd05aa3910fdec56
Patch0:		%{name}-system-spirv.patch
Patch1:		%{name}-symlink.patch
URL:		https://github.com/KhronosGroup/glslang
BuildRequires:	bison
BuildRequires:	cmake >= 3.14.0
BuildRequires:	libstdc++-devel >= 6:7
%if %{with tests} || %{with spirv_opt}
BuildRequires:	spirv-tools-devel >= 1:2022.4
%endif
%if %{with spirv_opt}
%requires_ge_to	spirv-tools-libs spirv-tools-devel
%endif
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
An OpenGL and OpenGL ES shader front end and validator.

%description -l pl.UTF-8
Frontend i walidator shaderów OpenGL i OpenGL ES.

%package devel
Summary:	Khronos reference front-end libraries for GLSL and ESSL
Summary(pl.UTF-8):	Wzorcowe biblioteki frontendowe GLSL i ESSL z projektu Khronos
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}

%description devel
A front-end libraries for programmatic parsing of GLSL/ESSL into an
AST.

%description devel -l pl.UTF-8
Biblioteki frontendowe do programowej analizy GLSL/ESSL do postaci
AST.

%prep
%setup -q
%patch0 -p1
%patch1 -p1

%build
%cmake -B build \
	%{!?with_spirv_opt:-DENABLE_OPT=OFF}

%{__make} -C build

%if %{with tests}
cd Test
LD_LIBRARY_PATH=../build/StandAlone
./runtests localResults ../build/StandAlone/glslangValidator ../build/StandAlone/spirv-remap
cd ..
%endif

%install
rm -rf $RPM_BUILD_ROOT

%{__make} -C build install \
	DESTDIR=$RPM_BUILD_ROOT

%clean
rm -rf $RPM_BUILD_ROOT

%post	-p /sbin/ldconfig
%postun	-p /sbin/ldconfig

%files
%defattr(644,root,root,755)
%doc LICENSE.txt README-spirv-remap.txt
%attr(755,root,root) %{_bindir}/glslang
%attr(755,root,root) %{_bindir}/glslangValidator
%attr(755,root,root) %{_bindir}/spirv-remap
%attr(755,root,root) %{_libdir}/libHLSL.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libHLSL.so.12
%attr(755,root,root) %{_libdir}/libSPIRV.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libSPIRV.so.12
%attr(755,root,root) %{_libdir}/libSPVRemapper.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libSPVRemapper.so.12
%attr(755,root,root) %{_libdir}/libglslang.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libglslang.so.12

%files devel
%defattr(644,root,root,755)
%doc README.md
%attr(755,root,root) %{_libdir}/libHLSL.so
%attr(755,root,root) %{_libdir}/libSPIRV.so
%attr(755,root,root) %{_libdir}/libSPVRemapper.so
%attr(755,root,root) %{_libdir}/libglslang.so
%{_libdir}/libglslang-default-resource-limits.a
%{_includedir}/glslang
%{_libdir}/cmake/glslang
%{_libdir}/cmake/HLSLTargets.cmake
%{_libdir}/cmake/SPIRVTargets.cmake
%{_libdir}/cmake/SPVRemapperTargets.cmake
%{_libdir}/cmake/glslang-default-resource-limitsTargets.cmake
%{_libdir}/cmake/glslang-standaloneTargets.cmake
%{_libdir}/cmake/spirv-remapTargets.cmake
%changelog
* Tue Sep 26 2023 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/glslang.git;a=log;h=master

* Tue Sep 26 2023 Jakub Bogusz <qboosh@pld-linux.org> 3786140
- updated to 12.3.1; patched to fix symlinking with DESTDIR and absolute CMAKE_INSTALL_BINDIR

* Tue Apr 04 2023 Jakub Bogusz <qboosh@pld-linux.org> a827034
- updated to 12.1.0 (new sonames)

* Mon Dec 27 2021 Jakub Bogusz <qboosh@pld-linux.org> d1c92ae
- updated to 11.7.1 (tagged also as sdk-1.2.198.0)

* Wed Apr 28 2021 Jakub Bogusz <qboosh@pld-linux.org> 412b65f
- rediffed

* Wed Apr 28 2021 Jakub Bogusz <qboosh@pld-linux.org> 634c8c7
- run ldconfig

* Wed Apr 28 2021 Jakub Bogusz <qboosh@pld-linux.org> b70087f
- updated to 11.1.0 (last version that builds with spirv-tools 2020.6; new libglslang soname)

* Sun Jul 05 2020 Jakub Bogusz <qboosh@pld-linux.org> eeb9265
- updated to 8.13.3743
- removed obsolete vulkan1.2 patch

* Sun Mar 15 2020 Jakub Bogusz <qboosh@pld-linux.org> fd4cb22
- updated to 8.13.3559
- removed outdated runtests patch, just use new runtests arguments
- added vulkan1.2 patch (Vulkan 1.2 support, required for shaderc 2019.1)

* Sat Jan 18 2020 Jan Palus <atler@pld-linux.org> b091f92
- release 2 (by relup.sh)

* Sat Jan 18 2020 Jan Palus <atler@pld-linux.org> 7519683
- add spirv_opt bcond; add versioned runtime dep on spirv-tools-libs

* Sat Sep 21 2019 Jakub Bogusz <qboosh@pld-linux.org> 6a12360
- Merge remote-tracking branch 'origin/SPIRV-1.3'

* Sat Sep 21 2019 Jan Palus <atler@pld-linux.org> bf8c063
- up to 7.12.3352

* Fri May 31 2019 Jakub Bogusz <qboosh@pld-linux.org> 3849af3
- -devel requires base, few libraries are shared now

* Fri May 31 2019 Jakub Bogusz <qboosh@pld-linux.org> 2466cb4
- updated to 7.11.3214 (targeted for SPIRV-1.3, python 2.x)
- added system-spirv patch (use system SPIRV-Tools libraries for tests)

* Sat Feb 10 2018 Jan Palus <atler@pld-linux.org> ee6519c
- up to 20180205 snap

* Fri May 26 2017 Jakub Bogusz <qboosh@pld-linux.org> 0187a0d
- pl, revised BRs
- adjusted runtests patch to use tools from build dir
- added libdir patch (honour LIB_SUFFIX), install process cleanup

* Mon Apr 03 2017 Jacek Konieczny <j.konieczny@eggsoft.pl> 6e2afc3
- newer snapshot for current vulkan-sdk

* Wed Nov 23 2016 Jacek Konieczny <j.konieczny@eggsoft.pl> 53d949b
- snapshot 20161029, for vulkan-sdk 1.0.32.0

* Thu Jul 14 2016 Jacek Konieczny <j.konieczny@eggsoft.pl> bfd9378
- Release: 2

* Thu Jul 14 2016 Jacek Konieczny <j.konieczny@eggsoft.pl> 4058043
- another take on isinf.patch

